#include <String.au3>
#include <Array.au3>
;Sieb von Eratosthenes, komprimiert
;
Global $z
Global $limit = 1299709 ;alle Primzahlen bis zum Limit finden


$arraysize = (Int($limit / 30) + 1) * 8  ;Array zur Aufnahme der mglichen Primzahlen, alle Vielfachen von 2,3 und 5 werden nicht bercksichtigt
Dim $a[$arraysize]
;der Vorteil ist, man braucht nur 1/4 des Speicherplatzes fr das Sieb

;es werden in diesem komprimierten Sieb alle Vielfachen von 2,3 und 5 nicht bercksichtigt, daraus ergibt sich eine "Matrix" mit mglichen Primzahlen
;Zahlen        Spalte
;            0    1    2    3    4    5    6    7
;Zeile
;0            1    7    11    13    17    19    23    29   in dieser Zeile stehen die Spaltenindizes
;1            31    37    41    43    47    49    53    59
;2            61    67    71    73    77    79    83    89
;3            91    97
;  Formel zur Berechnung der mglichen Primzahlen:
; Prim = Zeilenanzahl * 30 + Spaltenindex    Spaltenindex(0)=1 usw...
Dim $spaltenindex[8]   ;
$spaltenindex[0] = 1
$spaltenindex[1] = 7
$spaltenindex[2] = 11
$spaltenindex[3] = 13
$spaltenindex[4] = 17
$spaltenindex[5] = 19
$spaltenindex[6] = 23
$spaltenindex[7] = 29

;dann folgt ein Array, in dem die Spaltenindizes(+1) den Primzahlen von 0-30 zugeordnet werden
Dim $b[31] = [0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 3, 0, 4, 0, 0, 0, 5, 0, 6, 0, 0, 0, 7, 0, 0, 0, 0, 0, 8, 0]
;jede Vielfache der Primzahl soll aus der Matrix eliminiert werden, in der Matrix stehen aber nur Vielfache der Primen von 7 bis 29
;also wird nur die Zahl aus der Matrix eliminiert, bei der gilt:
;$b[Rest] <> 0    wobei Rest = mod ( Vielfaches der Prim , 30 )
;
;die Vielfachen der Primzahlen werden eliminiert, indem an ihre Position in der Matrix eine Zahl (zur Verdeutlichung das Vielfache) geschrieben wird
;Ist das Sieb fertiggestellt, sind die Arrayelemente mit 0 die Primzahlen, alle anderen sind eliminierte Vielfache

$tt = TimerInit()


$a[1]=1
$flag = 0
$primstring = ""

For $x = 0 To $arraysize     ;Anzahl aller mglichen Primzahlen in der Matrix
    For $y = 0 To 7           ;jedes Element in der Zeile
        If $a[$y + 1 + ($x * 8)]<>0 Then ContinueLoop ;nur Elemente mit 0 sind Primzahlen
        $prim = $x * 30 + $spaltenindex[$y]   ;das ist die Primzahl
        $qprim = $prim ^ 2  ;alle Vielfachen ab dem Quadrat dieser Primzahl eliminieren...
        If $qprim > $limit Then    ExitLoop 2  ;wenn Quadrat der Primzahl > Wurzel aus limit, dann besteht das sieb nur noch aus Primzahlen
        $r = Mod($qprim, 30)    ;mod der Zahl liefert den Rest
        $d = Int($qprim / 30)    ;int/30 liefert die Zeile der Zahl
        If $b[$r] <> 0 Then       ;wenn Zahl ein Vielfaches eines der Spaltenindizes, dann alle weiteren Vielfachen eliminieren
            $a[$b[$r] + ($d * 8)] = $prim    ;Im Arraydisplay sieht man sehr schn die eliminierten Vielfachen
            $t=timerinit()
            $w=0
            For $m = $qprim To $limit Step $prim  ;alle Vielfachen aus der Matrix eliminieren
                $r = Mod($m, 30)
                $d = Int($m / 30)
                If $b[$r] <> 0 Then
                    $a[$b[$r] + ($d * 8)] = $prim
                EndIf
                $w+=1   ;anzahl eliminierter Zahlen = Vielfache der Prim
            Next
            $m=timerdiff($t)
;~             ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $m = ' &$prim&"     "&$w&"   "& $m & @crlf & '>Error code: ' & @error & @crlf) ;### Debug Console
        endif
    Next
Next

$m = Round(TimerDiff($tt),4)
Msgbox(0,"Komprimiertes Sieb von Eratosthenes"," Primzahlen in "&int($m)&" Sekunden!" & @CRLF &"Bitte im Anschluss kurz auf das Arraydisplay warten....")
Exit
_ArrayDisplay($a)
$primstring = "2" & @CRLF & "3" & @CRLF & "5" & @CRLF
$n = 3
For $i = 1 To $arraysize - 2
    If $a[$i + 1] = 0 Then  ;Primzahl im Sieb gefunden
        $r = Mod($i, 8)
        $d = Int($i / 8)
        $n += 1
        $primstring &= $d * 30 + $spaltenindex[$r] & "   " & $n & @CR   ;Ausgabe der Primzahlen
    EndIf
Next
ConsoleWrite($primstring)
Exit
