#include <Array.au3>
#include <Memory.au3>
#include <FASM.au3>

Local $until = 1299709
Local $start = TimerInit()
Local $pz = Eratosthenes_Calc($until)
Local $stop = Round(TimerDiff($start) / 1000, 4)
MsgBox(0, "Laufzeit", $stop & " Sekunden")
Exit
Local $rowl = Ceiling(($until ^ 0.5) ^ 0.5)
Local $aTemp = StringSplit(StringMid($pz, 1, StringLen($pz) - 1), " ")
;~ _ArrayDisplay($aTemp)

#region GUI ini
Local $iMemo, $hGUI
Local $font_size = 9
Local $display = 0

If $display Then
	$w = StringLen($until) * $rowl * $font_size
	If $w < 400 Then
		$w = 400
	ElseIf $w > @DesktopWidth * 0.95 Then
		$w = @DesktopWidth * 0.95
	EndIf
	$h = @DesktopHeight * 0.9
Else
	$w = 400
	$h = 150
EndIf
#endregion

#region GUI
$hGUI = GUICreate("Prime Numbers Calculator by UEZ 2010", $w, $h, 0, 0)
$iMemo = GUICtrlCreateEdit("", 2, 2, $w - 4, $h - 6, 0x00200000 + 0x00100000 + 0x0800)
GUICtrlSetLimit(-1, 0x7FFFFFFF)
GUICtrlSetFont($iMemo, $font_size, 400, 0, "Courier New")
GUICtrlSetBkColor($iMemo, 0xFFFFFF)

MemoWrite("Sieving prime numbers till " & $until & ": " & @CRLF)
MemoWrite("Found " & $aTemp[0] & " prime numbers!" & @CRLF)
MemoWrite("Benchmark: " & Round($stop / 1000, 4) & " seconds to sieve prime numbers." & @CRLF)
If $display Then
	MemoWrite(@CRLF & "Numbers:" & @CRLF)
	For $z = 1 To $aTemp[0]
		MemoWrite(StringFormat("%" & StringLen($until) + 1 & "s", $aTemp[$z] & " "))
		If Mod($z, $rowl) = 0 Then MemoWrite(@CRLF)
	Next
EndIf
MemoWrite(@CRLF)
GUISetState()
#endregion

MouseClick("left", 100, 85, 1, 1)

While GUIGetMsg() <> -3
WEnd

Exit

Func MemoWrite($sMessage = "")
	GUICtrlSetData($iMemo, $sMessage, 1)
EndFunc   ;==>MemoWrite

Func Eratosthenes_Calc($l)
	Local $p[$l + 1], $i, $j, $z, $n
	For $z = 0x3 To $l Step 0x2
		$p[$z] = 0x1
	Next
	For $i = 0x3 To Sqrt($l) Step 0x2
		If $p[$i] And Mod($p[$i], 0x2) Then
			For $j = $i * $i To $l Step $i
				$p[$j] = 0
			Next
			$n &= $i & " "
		EndIf
	Next
	If Not Mod($i, 0x2) Then $i += 0x1
	For $z = $i To $l Step 0x2
		If $p[$z] Then $n &= $z & " "
	Next
	Return "2 " & $n
EndFunc